local RayUI, E, L, V, P, G = unpack(select(2, ...))

local IsAddOnLoaded = IsAddOnLoaded
local addon = "DeadlyBossMods"

if IsAddOnLoaded("DBM-Core") ~= true then return end

--Cache global variables

--WoW API / Variables

--Global variables that we don't cache, list them here for the mikk's Find Globals script
-- GLOBALS:

local _G, string = _G, string

function RayUI:LoadDBMProfile()
    --[[----------------------------------
	--	DeadlyBossMods - Settings
	--]]----------------------------------
	_G.DBM:CreateProfile("RayUI")

	_G.DBM_AllSavedOptions = {
		["RayUI"] = {
            ["DontShowFarWarnings"] = true,
            ["ChosenVoicePack"] = "None",
            ["DontShowHudMap2"] = false,
            ["AlwaysPlayVoice"] = false,
            ["ShowSWarningsInChat"] = true,
            ["DontShowNameplateLines"] = false,
            ["RangeFrameRadarY"] = -180.1268463134766,
            ["StatusEnabled"] = true,
            ["DontRestoreIcons"] = false,
            ["DontShowNameplateIcons"] = false,
            ["CoreSavedRevision"] = 20200210141512,
            ["RangeFrameX"] = -373.2606201171875,
            ["RangeFrameY"] = -72.49996948242188,
            ["FilterInterruptNoteName"] = false,
            ["EnableModels"] = true,
            ["SpecialWarningFlashAlph3"] = 0.4,
            ["ArrowPoint"] = "TOP",
            ["SWarnNameInNote"] = true,
            ["FakeBWVersion"] = false,
            ["InfoFramePoint"] = "RIGHT",
            ["EventSoundMusicCombined"] = false,
            ["SpecialWarningFlashCol2"] = {
                1, -- [1]
                0.5, -- [2]
                0, -- [3]
            },
            ["WarningAlphabetical"] = true,
            ["WarningFont"] = "Fonts\\ARKai_T.ttf",
            ["CheckGear"] = true,
            ["DontShowReminders"] = false,
            ["WorldBossAlert"] = false,
            ["DontShowPT2"] = false,
            ["DontShowSpecialWarnings"] = false,
            ["MoviesSeen"] = {
                [656] = true,
                [567] = true,
                [1364] = true,
                [682] = true,
                [16] = true,
            },
            ["ShowQueuePop"] = true,
            ["ShowAllVersions"] = true,
            ["DebugMode"] = false,
            ["DontShowTargetAnnouncements"] = true,
            ["ShowWarningsInChat"] = true,
            ["SpecialWarningFontCol"] = {
                1, -- [1]
                0.7, -- [2]
                0, -- [3]
            },
            ["WarningFontStyle"] = "None",
            ["EventSoundEngage2"] = "None",
            ["InfoFrameY"] = -170.0372619628906,
            ["ChatFrame"] = "DEFAULT_CHAT_FRAME",
            ["WarningIconRight"] = true,
            ["UseSoundChannel"] = "Master",
            ["RangeFrameRadarX"] = -358.1010437011719,
            ["ShowRespawn"] = true,
            ["EventSoundWipe"] = "None",
            ["AlwaysShowSpeedKillTimer2"] = false,
            ["FilterDispel"] = true,
            ["DebugLevel"] = 1,
            ["LFDEnhance"] = true,
            ["SpecialWarningFlashDura1"] = 0.4,
            ["DontShowPTNoID"] = false,
            ["HideGarrisonToasts"] = true,
            ["RangeFramePoint"] = "RIGHT",
            ["SpecialWarningFontShadow"] = false,
            ["EventMusicMythicFilter"] = true,
            ["HideBossEmoteFrame2"] = true,
            ["HideObjectivesFrame"] = true,
            ["SpecialWarningFlashCol1"] = {
                1, -- [1]
                1, -- [2]
                0, -- [3]
            },
            ["DontShowPTText"] = false,
            ["SpecialWarningFontSize2"] = 35,
            ["SpecialWarningFlashCol5"] = {
                0.2, -- [1]
                1, -- [2]
                1, -- [3]
            },
            ["SpecialWarningFlashAlph4"] = 0.4,
            ["PTCountThreshold2"] = 5,
            ["SpecialWarningFlashCount2"] = 1,
            ["HelpMessageVersion"] = 3,
            ["EventSoundDungeonBGM"] = "None",
            ["EventSoundTurle"] = "None",
            ["CountdownVoice2"] = "Kolt",
            ["AutoAcceptGuildInvite"] = false,
            ["SpecialWarningFlashCount4"] = 2,
            ["ArrowPosX"] = 0,
            ["FilterInterrupt2"] = "TandFandBossCooldown",
            ["AITimer"] = true,
            ["SpecialWarningFlashDura3"] = 1,
            ["WarningShortText"] = true,
            ["LatencyThreshold"] = 250,
            ["ForumsMessageShown"] = false,
            ["SpecialWarningFlash4"] = true,
            ["DontShowPTCountdownText"] = false,
            ["EventSoundMusic"] = "None",
            ["DisableSFX"] = false,
            ["AutologBosses"] = false,
            ["SpecialWarningFlashDura4"] = 0.7,
            ["DisableGuildStatus"] = false,
            ["AutoReplySound"] = true,
            ["SpecialWarningFlashCol3"] = {
                1, -- [1]
                0, -- [2]
                0, -- [3]
            },
            ["WarningColors"] = {
                {
                    ["r"] = 0.4117647058823529,
                    ["g"] = 0.8,
                    ["b"] = 0.9411764705882353,
                }, -- [1]
                {
                    ["r"] = 0.9490196078431372,
                    ["g"] = 0.9490196078431372,
                    ["b"] = 0,
                }, -- [2]
                {
                    ["r"] = 1,
                    ["g"] = 0.5019607843137255,
                    ["b"] = 0,
                }, -- [3]
                {
                    ["r"] = 1,
                    ["g"] = 0.1019607843137255,
                    ["b"] = 0.1019607843137255,
                }, -- [4]
            },
            ["FilterTrashWarnings2"] = true,
            ["SWarningAlphabetical"] = true,
            ["SpecialWarningX"] = 0,
            ["BlockNoteShare"] = false,
            ["WarningPoint"] = "CENTER",
            ["ShowGuildMessages"] = true,
            ["SpecialWarningSound2"] = 15391,
            ["ModelSoundValue"] = "Short",
            ["ArrowPosY"] = -150,
            ["HideQuestTooltips"] = true,
            ["MovieFilter2"] = "OnlyFight",
            ["RangeFrameRadarPoint"] = "RIGHT",
            ["DontShowInfoFrame"] = false,
            ["SpecialWarningFlashRepeat1"] = false,
            ["AdvancedAutologBosses"] = false,
            ["RangeFrameUpdates"] = "Average",
            ["AutoCorrectTimer"] = false,
            ["DontRestoreRange"] = false,
            ["RaidWarningSound"] = 11742,
            ["CustomSounds"] = 0,
            ["ShortTimerText"] = true,
            ["SpecialWarningFlashCount3"] = 3,
            ["RoleSpecAlert"] = true,
            ["WhisperStats"] = false,
            ["VoiceOverSpecW2"] = "DefaultOnly",
            ["LogOnlyNonTrivial"] = true,
            ["DontPlayPTCountdown"] = false,
            ["SpecialWarningFlashAlph5"] = 0.5,
            ["SpecialWarningDuration2"] = 1.5,
            ["WarningY"] = 260,
            ["ShowEngageMessage"] = true,
            ["WarningIconLeft"] = true,
            ["RangeFrameSound1"] = "none",
            ["RangeFrameLocked"] = false,
            ["WarningFontSize"] = 20,
            ["EventSoundVictory2"] = "None",
            ["SpecialWarningFlashDura2"] = 0.4,
            ["LastRevision"] = 0,
            ["DontShowSpecialWarningText"] = false,
            ["SettingsMessageShown"] = true,
            ["SpecialWarningFlashRepeat3"] = true,
            ["RangeFrameSound2"] = "none",
            ["SpecialWarningFlashCol4"] = {
                1, -- [1]
                0, -- [2]
                1, -- [3]
            },
            ["DontShowBossAnnounces"] = false,
            ["DontSetIcons"] = false,
            ["BigBrotherAnnounceToRaid"] = false,
            ["WarningX"] = 0,
            ["CountdownVoice"] = "Corsica",
            ["BonusFilter"] = "Never",
            ["CountdownVoice3"] = "Smooth",
            ["SpecialWarningFlashRepeat2"] = false,
            ["DontShowUserTimers"] = false,
            ["SpecialWarningFlashRepeat5"] = true,
            ["DisableStatusWhisper"] = false,
            ["EventDungMusicMythicFilter"] = true,
            ["SpecialWarningFlashRepeat4"] = false,
            ["RangeFrameFrames"] = "radar",
            ["DontPlayCountdowns"] = false,
            ["ShowBigBrotherOnCombatStart"] = false,
            ["SpecialWarningIcon"] = true,
            ["DontShowRangeFrame"] = false,
            ["SpecialWarningFlashAlph1"] = 0.3,
            ["ShowDefeatMessage"] = true,
            ["FilterTankSpec"] = true,
            ["WarningDuration2"] = 1.5,
            ["SpecialWarningFont"] = "Fonts\\ARKai_T.ttf",
            ["InfoFrameShowSelf"] = false,
            ["WarningFontShadow"] = true,
            ["SpecialWarningFlashDura5"] = 1,
            ["SpecialWarningFlashAlph2"] = 0.3,
            ["DontShowBossTimers"] = false,
            ["SpecialWarningFontStyle"] = "THICKOUTLINE",
            ["SpecialWarningPoint"] = "CENTER",
            ["AutoRespond"] = true,
            ["RecordOnlyBosses"] = false,
            ["WorldBossNearAlert"] = false,
            ["InfoFrameLines"] = 0,
            ["InfoFrameX"] = -488.814697265625,
            ["SpecialWarningFlashRepeatAmount"] = 2,
            ["AutoAcceptFriendInvite"] = false,
            ["WarningIconChat"] = true,
            ["SpecialWarningFlashCount1"] = 1,
            ["HideGuildChallengeUpdates"] = true,
            ["SpecialWarningSound5"] = 128466,
            ["DontSendYells"] = false,
            ["ShowPizzaMessage"] = true,
            ["SpecialWarningFlash2"] = true,
            ["HideTooltips"] = false,
            ["SpecialWarningFlash3"] = true,
            ["SpecialWarningY"] = 75,
            ["Enabled"] = true,
            ["RLReadyCheckSound"] = true,
            ["SpecialWarningShortText"] = true,
            ["FilterVoidFormSay"] = true,
            ["SpecialWarningSound3"] = "Interface\\AddOns\\DBM-Core\\sounds\\AirHorn.ogg",
            ["SpecialWarningSound"] = 8174,
            ["ShowGuildMessagesPlus"] = false,
            ["LogOnlyRaidBosses"] = false,
            ["StripServerName"] = true,
            ["SWarnClassColor"] = true,
            ["SpecialWarningSound4"] = 9278,
            ["SpecialWarningFlash5"] = true,
            ["SpecialWarningFlashCount5"] = 3,
            ["AFKHealthWarning"] = false,
            ["SpecialWarningFlash1"] = true,
            ["ShowFlashFrame"] = true,
        },
	}

	_G.DBT_AllPersistentOptions = {
		["RayUI"] = {
            ["DBM"] = {
                ["StartColorPR"] = 1,
                ["Scale"] = 1,
                ["EnlargeBarsPercent"] = 0.125,
                ["StartColorR"] = 1,
                ["EndColorPR"] = 0.5019607843137255,
                ["ExpandUpwardsLarge"] = true,
                ["TimerPoint"] = "TOPLEFT",
                ["EndColorDG"] = 0,
                ["Alpha"] = 0.800000011920929,
                ["HugeTimerPoint"] = "CENTER",
                ["EndColorUIG"] = 0.9215686274509803,
                ["StartColorUIR"] = 1,
                ["StartColorAG"] = 0.5450980392156862,
                ["EndColorDR"] = 1,
                ["TDecimal"] = 11,
                ["StartColorRR"] = 0.5019607843137255,
                ["StartColorUIG"] = 1,
                ["HugeScale"] = 1,
                ["BarYOffset"] = 2,
                ["StartColorDG"] = 0.3019607843137255,
                ["StartColorAR"] = 0.3764705882352941,
                ["EndColorAER"] = 1,
                ["StartColorIB"] = 1,
                ["Font"] = "Fonts\\ARKai_T.ttf",
                ["EndColorAEB"] = 0.2470588235294118,
                ["Height"] = 22,
                ["BarXOffset"] = 0,
                ["EndColorB"] = 0,
                ["EndColorAR"] = 0.1490196078431373,
                ["EndColorG"] = 0,
                ["EndColorIB"] = 1,
                ["HugeWidth"] = 250,
                ["TimerX"] = 364.0013122558594,
                ["EndColorIR"] = 0.04705882352941176,
                ["HugeAlpha"] = 1,
                ["Texture"] = "Interface\\AddOns\\ElvUI_MerathilisUI\\media\\textures\\mUI4.tga",
                ["EnlargeBarTime"] = 11,
                ["StartColorPG"] = 0.7764705882352941,
                ["FontFlag"] = "OUTLINE",
                ["EndColorAB"] = 1,
                ["Width"] = 200,
                ["EndColorPG"] = 0.4117647058823529,
                ["EndColorIG"] = 0.8784313725490196,
                ["EndColorAEG"] = 0.04313725490196078,
                ["StartColorAEB"] = 0.4588235294117647,
                ["HugeTimerY"] = 172.3170776367188,
                ["EndColorUIB"] = 0.01176470588235294,
                ["StartColorIG"] = 0.9686274509803922,
                ["HugeBarYOffset"] = 5,
                ["StartColorB"] = 0,
                ["StartColorAB"] = 1,
                ["FontSize"] = 10,
                ["StartColorRB"] = 0.5019607843137255,
                ["StartColorAEG"] = 0.4666666666666667,
                ["EndColorRB"] = 0.3019607843137255,
                ["StartColorPB"] = 0.4196078431372549,
                ["EndColorRR"] = 0.1098039215686275,
                ["EndColorUIR"] = 1,
                ["EndColorRG"] = 1,
                ["StartColorUIB"] = 0.06274509803921569,
                ["StartColorG"] = 0.7019607843137254,
                ["HugeBarXOffset"] = 0,
                ["StartColorDR"] = 0.9019607843137255,
                ["EndColorR"] = 1,
                ["StartColorRG"] = 1,
                ["EndColorPB"] = 0.2862745098039216,
                ["StartColorAER"] = 1,
                ["EndColorAG"] = 0.3843137254901961,
                ["StartColorIR"] = 0.4705882352941176,
                ["StartColorDB"] = 1,
                ["EndColorDB"] = 1,
                ["TimerY"] = -152.0000610351563,
                ["HugeTimerX"] = -342.1639099121094,
            },
        },
	}

	_G.DBM:ApplyProfile("RayUI")
end

local function DBMTable()
	E.Options.args.rayui.args.addons.args[addon] = {
		order = 1,
		type = "execute",
		name = addon,
		desc = string.format(L["This will create and apply profile for %s"], addon),
		func = function()
			RayUI:LoadDBMProfile()
			-- RayUI:Print(profileString..addon)
		end,
		disabled = function() return not IsAddOnLoaded("DBM-Core") end,
	}
end

tinsert(RayUI.Config, DBMTable)
